;;;
;;; scbib - a bibliography management system written in Scheme
;;;
;;; Copyright (C) 2004 Satoru Takabayashi <satoru@namazu.org> 
;;;     All rights reserved.
;;;     This is free software with ABSOLUTELY NO WARRANTY.
;;;
;;; You can redistribute it and/or modify it under the terms of 
;;; the Gauche's licence.
;;;

(define-module scbib.amazon
  (use gauche.parameter)
  (export scbib-amazon-locale
          scbib-amazon-token
          scbib-amazon-associate-id
          scbib-amazon-web-url
          scbib-amazon-xml-url
          ))
(select-module scbib.amazon)

(define scbib-amazon-locale (make-parameter "jp"))

(define scbib-amazon-token (make-parameter "yourtoken"))

(define scbib-amazon-associate-id (make-parameter ""))

(define scbib-amazon-web-url
  (let ((web-host-table (list (cons "jp" "amazon.co.jp")
                              (cons "fr" "amazon.fr")
                              (cons "de" "amazon.de")
                              (cons "uk" "amazon.uk")
                              (cons "ca" "amazon.ca")
                              (cons "us" "amazon.com"))))
    (lambda (asin)
      (let* ((locale (scbib-amazon-locale))
             (host (if (assoc locale web-host-table)
                       (cdr (assoc locale web-host-table))
                       "amazon.com")))
        (format #f "http://~a/o/ASIN/~a/~a" 
                host
                asin
                (scbib-amazon-associate-id))))))

(define scbib-amazon-xml-url
  (let ((xml-host-table (list (cons "jp" "xml.amazon.co.jp")
                              (cons "fr" "xml-eu.amazon.com")
                              (cons "de" "xml-eu.amazon.com")
                              (cons "uk" "xml-eu.amazon.com")
                              (cons "ca" "xml.amazon.com")
                              (cons "us" "xml.amazon.com"))))
    (lambda (asin)
      (let* ((locale (scbib-amazon-locale))
             (token  (scbib-amazon-token))
             (host (if (assoc locale xml-host-table)
                       (cdr (assoc locale xml-host-table))
                       "xml.amazon.com")))
        (format 
         "http://~a/onca/xml3?t=~a&dev-t=~a&AsinSearch=~a&type=~a&f=~a&locale=~a"
         host "webservices-20" token asin "heavy" "xml" locale)))))
